<template>
  <div style="width: 98%">
    <treeselect
      ref="refRuleTreeselect"
      :options="getOptions"
      :disable-branch-nodes="true"
      :show-count="true"
      :value="localValue"
      placeholder="Select a field"
      no-results-text="Field not found"
      clear-value-text="Remove field"
      no-options-text="No fields available"
      no-children-text="No sub-fields"
      :default-expand-level="0"
      search-nested
      @input="updateSelection"
    >
      <label
        slot="option-label"
        slot-scope="{
          node,
          shouldShowCount,
          count,
          labelClassName,
          countClassName,
        }"
        :class="
          'text-' + node.raw.color + ' font-weight-bold ' + labelClassName
        "
      >
        <b-container class="m-0 p-0" fluid>
          <b-row no-gutters>
            <b-col class="mr-2">
              <span>{{ node.label }}</span>
              <span v-if="shouldShowCount" :class="countClassName"
                >({{ count }})</span
              >
            </b-col>
          </b-row>
          <b-row no-gutters>
            <b-col style="font-size: 0.9em; line-height: 1.1" class="mr-2">
              <span class="small font-italic text-wrap text-muted">
                {{ node.raw.description }}
              </span>
            </b-col>
          </b-row>
        </b-container>
      </label>
      <div
        slot="value-label"
        slot-scope="{ node }"
        :class="'text-' + node.raw.color"
      >
        <span>{{ node.label }}</span>
      </div>
    </treeselect>
  </div>
</template>
<script>
import Treeselect from '@riophae/vue-treeselect';
import '@riophae/vue-treeselect/dist/vue-treeselect.css';
import queryFactoryConstants from '../../../constants/queryFactory';
export default {
  components: {
    Treeselect,
  },
  props: {
    value: {
      type: String,
      default: () => '',
      required: true,
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    rule: {
      type: Object,
      default: () => {},
    },
    ruleProperties: {
      type: Object,
      default: () => {},
    },
    options: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      localValue: this.value,
    };
  },
  computed: {
    getOptions() {
      return this.transformData(this.ruleProperties?.options?.properties?.data);
    },
  },
  mounted() {
    if (!this.localValue) {
      this.$set(this.rule, 'isDataCompleted', false);
    }
  },
  methods: {
    updateSelection(newValue) {
      if (this.disabled) return;
      if (!newValue) {
        this.$set(this.rule, 'isDataCompleted', false);
        this.localValue = null;
        this.$emit('input', '');
      } else {
        this.$set(this.rule, 'isDataCompleted', true);
        this.localValue = newValue;
        this.$emit('input', newValue);
      }
    },
    transformData(jsonData) {
      return jsonData.map((item) => {
        const transformedItem = {
          id: item.key,
          label: item.title,
          description: item.description,
          color: queryFactoryConstants.identifierPartLabelColor.fields,
        };
        if (
          item.options?.properties?.data &&
          item.options.properties.data.length > 0
        ) {
          transformedItem.color =
            queryFactoryConstants.identifierPartLabelColor.entities;
          transformedItem.children = this.transformData(
            item.options.properties.data
          );
        }
        return transformedItem;
      });
    },
  },
};
</script>
<style scoped>
::v-deep .vue-treeselect__single-value {
  color: #7955af !important;
  font-weight: 500;
}
::v-deep .vue-treeselect__placeholder {
  margin-left: 3px !important;
  color: #6574cd !important;
  font-weight: 450;
}
::v-deep .vue-treeselect__input {
  color: #7955af !important;
}
</style>
